
                                                           GLIB(1) LOCAL



NAME
     glib - patch editor and librarian for synthesizers

SYNOPSIS
     glib

DESCRIPTION
     Glib (one syllable) is a text-screen-oriented librarian and editor.
     It is structured in an attempt to make it easy to add support for
     new synthesizers.  Information on how to do this can be found
     below.  The librarian part of the program manipulates 1 synth bank
     of voices (which can be uploaded to or downloaded from the synth),
     and 3 banks of library voices (which can be read/written to disk).
     All synths are supported simultaneously; you can switch back and
     forth and the library banks and other settings (e.g. midi channel)
     for each are retained.

     You can run glib on Unix (it uses curses), although obviously most
     Unix machines don't have midi I/O.  Trying it out on Unix will give
     you a feel for what the program does, so you can decide whether or
     not it's worth the trouble to port it to your midi-capable PC.

     Included is at least 1 bank of voices for each synth type that glib
     supports.  The bank files (ending in .uu) are uuencoded.  You need
     to run uudecode to produce the real binary file for each.  The
     suffix conventions:

                  .dx1 = dx100
                  .tx8 = tx81z
                  .t8p = tx81performance
                  .dw8 = dw8000
                  .pat = d10 performance mode patches
                  .tim = d10 multi-timbral mode timbres
                  .ton = d10 tone: wave-form generators,
				time variant filters/amplitudes
                  .rsu = d10 rhythm setup
                  .urp = d10 rhythm patterns
                  .tra = d10 rhythm track
                  .sgl = k1 single patch
                  .mlt = k1 multi patch


Using glib - Moving around
     Both the librarian and editor parts of glib make use of arrow keys,
     <CTRL/B> <CTRL/N> <CTRL/P> <CTRL/F> or h j k l to move the cursor
     around.  <CTRL/L> redraws the screen.  These keys are #defined in
     glib.h, so you can change them if you want.  To quit from any mode,
     use q. In the librarian screen, ? gives a command summary.  Esc
     sends an all-notes-off (though the support for arrow keys may
     interfere with this convention).


Using glib - The librarian
     The screen shows the synth bank on the left, and the current (1 of
     3) library bank on the right.  A * identifies the `current' voice,
     and you use the arrow keys to move it around.  As soon as you move
     to a different voice, it is sent to the `edit buffer' of the synth,
     so it is very easy to roam around and see what each voice sounds
     like.  Commands:

     b -  Cycle through the (3) library banks, displayed on the right
          side of the screen.

     c -  Set the midi channel for sending/receiving voices.

     d -  Download from the (real) synthesizer, replacing the current
          contents of the synth bank.

     e -  Edit the current voice (see editor description below).

     f -  List the files on the disk.

     p -  Put the yank buffer, replacing the contents of the current
          voice.

     q -  Quit, going back to `choose a synth'.

     r -  Read a bank of voices from a file, replacing entirely the
          current library bank.

     R -  Read a bank of voices from a text file (created with the W
          command).

     s -  Swap the current voice with the yank buffer.  2 swaps is a
          no-op.

     t -  Transfer all voices, either from the current library bank to
          the synth bank, or vice versa.

     u -  Upload the current contents of the synth bank to the synth.
          You are given a choice of sending the entire bank or just the
          current voice.

     w -  Write the current library bank to a file.

     W -  Write the current library bank to an editable text file.  This
          is slow, and is meant for use in some special circumstance -
          for instance if you changed the binary format of files, you
          might want to convert your old patches.

     y -  Yank the current voice into the yank buffer, shown in the
          middle of the screen.


Using glib - The editor
     In the editor part, arrow keys move the cursor among the parameter
     values.  The cursor will only land on parameter values.  Once on a
     parameter value, the following keys will affect it:

               K - increase value by 1
               J - decrease value by 1
               I - increase value by 4
               M - decrease value by 4
               < - decrease value to its minimum
               > - increase value to its maximum
               S - same value as last assigned

     These keys are also defined in glib.h, and should be changed to
     suit your own tastes.  I'm not thrilled with these choices, myself,
     but I had to use something, and at least the hand may stay in one
     place.

     To change the name of a voice, use `N'.

     The `auto-note' is played whenever you press the space bar.  This
     is a convenient way of playing a note as soon as you make a change
     (ie.  you can do everything from the computer keyboard).  You can
     change the auto-note parameters (pitch, duration, volume, channel)
     the same way as all the other parameters.

     For Kawai K1 multi patches, names of single patches referred to are
     displayed when they can be found in the synth voice bank of the
     single patches module.  The names are updated whenever a new bank
     of voices is transferred into this bank.

AUTHORS
     original version for dx100, tx81z, dep5:  Tim Thompson,
     		...twitch!glimmer!tjt
     Macintosh and dw1000 support:  Steve Falco.
     d10 support:  Michael Kesti, mrk@gvgspd.GVG.TEK.COM
     Amiga and k5 support:  Alan Bland, mab@druwy.ATT.COM or
     		att!druwy!mab
     K1 support and menu mods:  Greg Lee, lee@uhccux.uhcc.hawaii.edu
