/*
** mdr.h - header file for stuff that uses the midi driver
**
** Steven A. Falco  7/30/87
*/

#define MIDI_NE		0		/* queue has 1 or more bytes available */
#define MIDI_EM		(-1)	/* queue is empty */

extern void midi_init();	/* set up hardware & software */
extern void midi_reset();	/* unset - very important to avoid crashes */
extern void midi_tx();		/* send a byte (but declare arg as a long) */
extern long midi_rx();		/* get a byte (returns -1 on "nothing available" */
extern char midi_txst;		/* transmit queue state (flags above) */
extern char midi_rxst;		/* receive queue state */
extern long midi_time;		/* relative time in mS (5 mS granularity) */
